// Listing 3.5: berschreiben eines von einem NSURLConnection-Objekt genutzten Trust-Objekts
// abgeleitet aus Listing 3 aus [Appl_13.16]

-(void)connection:(NSURLConnection *)connection
        willSendRequestForAuthenticationChallenge:(NSURLAuthenticationChallenge *)challenge
        
{
    NSURLProtectionSpace *protectionSpace = [challenge protectionSpace];
    if ([protectionSpace authenticationMethod] == NSURLAuthenticationMethodServerTrust) {
    SecTrustRef trust = [protectionSpace serverTrust];
 
    // Hier wird die Trust Policy an die gewnschten Bedingungen angepasst
 
    // Prfen, ob die Trust Policy gltig ist
    SecTrustResultType secresult = kSecTrustResultInvalid;
    if (SecTrustEvaluate(trust, &secresult) != errSecSuccess) {
        // Trust Policy ist nicht gltig
 
        // Ggf. Fehlermeldung ausgeben oder in Logfile schreiben
        
        // Verbindung beenden
        [connection cancel];
 
        // Ggf. weitere Aufrumarbeiten

        return;
    }
 
    switch (secresult) {
        case kSecTrustResultUnspecified: 
             // iOS vertraut diesem Zertifikat implizit
        case kSecTrustResultProceed: 
             // Wir sagen iOS explizit, dass es dem Zertifikat vertrauen darf
             {
                 NSURLCredential *credential =
                 [NSURLCredential credentialForTrust:challenge.protectionSpace.serverTrust];
                 [challenge.sender useCredential:credential forAuthenticationChallenge:challenge];
                 return;
             }
        default:
             // Wir haben mit dem Schlssel nichts zu tun
    }
    
    // Der Server sendete einen anderen als den von uns vertrauten Schlssel
    // Verbindung beenden
    [connection cancel];
 
    // Ggf. weitere Aufrumarbeiten
    }
}