// Listing 8.1: Beispiel fr die Authentifizierung mittels connection:didReceiveAuthenticationChallenge:
// nach Listing 6-1 aus [Appl_13.16]

-(void)connection:(NSURLConnection *)connection
        didReceiveAuthenticationChallenge:(NSURLAuthenticationChallenge *)challenge
{
    if ([challenge previousFailureCount] == 0) {
        // Bisher gab es keinen Fehlversuch: Authentifizierung starten
        
        // neue NSURLCredential-Instanz erzeugen
        NSURLCredential *newCredential;
        
        // Benutzername und Passwort aus den Preferences bernehmen
        newCredential = [NSURLCredential credentialWithUser:[self preferencesName]
                                         password:[self preferencesPassword]
                                         persistence:NSURLCredentialPersistenceNone];
        // Zugangsdaten an den Server senden
        [[challenge sender] useCredential:newCredential
                            forAuthenticationChallenge:challenge];
    } else {
        // Es gab schon einen Fehlversuch
        
        // Authentifizierung abbrechen
        [[challenge sender] cancelAuthenticationChallenge:challenge];
        
        // Informieren des Benutzers, dass Benutzername und/pder Password 
        // in den Preferences ungltig sind
        [self showPreferencesCredentialsAreIncorrectPanel:self];
    }
}
